/* ǾФ륯饹ˡΥץ */

#include <stdio.h>
#include <math.h>
#include <stdarg.h>
#define N 1000       /* ξ */
#define M 5000       /* ޿ξ */
#define ZERO 0.0001  /* ݤε */

#define TCLTKMODE     /* TCLTK */

struct edge          /* ¤edge */
{
 float d;            /* Ĺ */
 int end1, end2;     /* ξü */
};
struct set           /* ¤set */
{
 int size[N];
 int root[N];
 int parent[N];
};

/* ؿ */
void kruskal(struct edge *E, struct edge *T, int n, int m);
void quicksort(int i, int j, struct edge *A);
int partition(int i, int j, float a, struct edge *A);
int pivot(int i, int j, struct edge *A);
void swap(int i, int j, struct edge *A);
void treemerge(int i, int k, struct set *S);
int treefind(int j, struct set *S);
void printorg(char *s, ...){
#ifndef TCLTKMODE
  va_list ap;
  va_start(ap, s);
  vprintf(s, ap);
  va_end(ap);
#endif
}
void printtcltk(char *s, ...){
#ifdef TCLTKMODE
  va_list ap;
  va_start(ap, s);
  vprintf(s, ap);
  va_end(ap);
#endif
}

int main()
/* ǾڤΥ르ꥺΥƥȥץ */
{
 struct edge E[M], T[N-1];    /* ޽E, ǾT */
 int i, k, n, m, width;
 /*FILE *file;*/
 FILE *file = stdin;

 /*file=fopen("edgedata", "r");*/
    {
#ifdef TCLTKMODE
     fscanf(file, "%d", &width);
#endif
     fscanf(file, "%d", &n);
     fscanf(file, "%d", &m);
    }
 for(i=0; i<m; i++)
   {
    fscanf(file, "%f", &E[i].d);
    fscanf(file, "%d", &E[i].end1);
    fscanf(file, "%d", &E[i].end2);
   }
 printorg("n = %d, m = %d\n", n, m);
 printorg("edges; d  end1  end2 \n");
 for(i=0; i<m; i++) 
    printorg("%f, %d, %d\n", E[i].d, E[i].end1, E[i].end2);
 /**** begin: TCLTK output ****/
 printtcltk("begingraph\n");
 printtcltk("width      %d\n", width);
 printtcltk("nodenum    %d\n", n);
 printtcltk("edgenum    %d\n", m);
 printtcltk("nodestart  0\n");
 for(i=0; i<m; i++) 
    printtcltk("edge %.1f %d %d\n", E[i].d, E[i].end1, E[i].end2);
 printtcltk("endgraph\n");
 /**** end:   TCLTK output ****/
 kruskal(E, T, n, m);
 printtcltk("end\n");
 printorg("MST edges\n");
 for(k=0; k<n-1; k++) 
   printorg("%f, %d, %d\n", T[k].d, T[k].end1, T[k].end2);


 return 1;
}

void kruskal(struct edge *E, struct edge *T, int n, int m)
/* n, ޿m, ޽EĥդκǾڤ
饹Υ르ꥺ; ̤T */
{
 struct set comp;           /* ׻ɬפʽ²ʿˤɽ */
 int i, j, k, s1, s2;

 for(j=0; j<n; j++)         /* compν */
   {
    comp.size[j]=1; comp.root[j]=j; comp.parent[j]=-j-1;
   }
 quicksort(0, m-1, E);      /* ޽E */
 k=0; i=0;                  /* 饹Υ르ꥺȿ */
 while(k<n-1)
   {
    s1=treefind(E[i].end1, &comp);  /* E[i]ξüνs1s2 */
    s2=treefind(E[i].end2, &comp);
    /**** begin: Tcl/Tk ****/
    printtcltk("step\n");
    if(s1==s2)
      printtcltk("coloredge %d %d gray\n", E[i].end1, E[i].end2);
    else
      printtcltk("coloredge %d %d red\n", E[i].end1, E[i].end2);
    /**** end: Tcl/Tk ****/
    if(s1!=s2)              /* s1s2ʻ */
      {
       treemerge(s1, s2, &comp);
       T[k]=E[i];
       k=k+1;
      }
    i=i+1;
   }
/* printorg("final sets comp\n");
 for(i=0; i<n; i++) printorg("%d, %d, %d\n", i, comp.size[i], comp.root[i]);
 printorg("parents\n");
 for(j=0; j<n; j++) printorg("%d, %d\n", j, comp.parent[j]); */
 return;
}

void quicksort(int i, int j, struct edge *A)
/* A[i],...,A[j]򥯥åȤˤ */
{
 int a, pv, k;

 pv=pivot(i, j, A);
 if(pv!=-1)
   {
    a=A[pv].d;
    k=partition(i, j, a, A);
    quicksort(i, k-1, A);
    quicksort(k, j, A);
   }
 return;
}

int partition(int i, int j, float a, struct edge *A)
/* A[i],...,A[j]aˤäʬ */
/* ȾA[i],...,A[k-1]<a, ȾA[k],...,A[j]>=a */
{
 int l, r, k;
 l=i; r=j;

 while(A[l].d < a-ZERO) l=l+1; while(A[r].d+ZERO >= a) r=r-1;
 while(l<=r)
   {
    swap(l, r, A); l=l+1; r=r-1;
    while(A[l].d < a-ZERO) l=l+1; while(A[r].d+ZERO >= a) r=r-1;
   }
 k=l;
 return(k);
}

int pivot(int i, int j, struct edge *A)
/* A[i],...,A[j]鼴A[pv]pv */
/* A[pv]A[i]Ⱥǽ˰ۤʤA[k]礭٤Ʊʤpv=-1 */
{
 int pv, k;

 k=i+1;
 while(fabs(A[i].d-A[k].d)<=ZERO && k<=j) k=k+1;
 if(k>j) pv=-1;
 else if(A[i].d >= A[k].d) pv=i;
 else pv=k;
 return(pv);
}


void swap(int i, int j, struct edge *A)
/* ¤A[i]A[j]θ */
{
 struct edge temp;

 temp=A[i]; A[i]=A[j]; A[j]=temp;
 return;
}


void treemerge(int i, int k, struct set *S)
/* ikΣĤڤʻ */
{
 int j, large, small;

 if(S->size[i] <= S->size[k]) {small=i; large=k;}
 else {small=k; large=i;}
 j=S->root[small];
 if(S->size[small] == 0) return;
 S->parent[j] = S->root[large];
 S->size[large] = S->size[large]+S->size[small];
 S->size[small] = 0;
 S->root[small] = -1;
 return;
}

int treefind(int j, struct set *S)
/* jǤȤ뽸iνϤϩΰ */
{
 int i, k, temp;
 k=j;

 while(k>=0) k = S->parent[k];
 i = -k-1;
 k=j;
 while(k>=0) 
   {
    temp = S->parent[k];
    if(temp>=0) S->parent[k] = S->root[i];
    k=temp;
   }
 return(i);
}
